﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kursach
{

    public class LinkedList<T>
    {
        private Node<T>? head;
        private Node<T>? tail;
        private int numElems;
        public LinkedList()
        {
            head = null;
            tail = null;
            numElems = 0;
        }
        public void AddLast(T value)
        {
            Node<T> node = new Node<T>(value);
            if (head == null)
            {
                head = node;
            }
            else
            {
                tail.next = node;
            }
            tail = node;
            numElems++;
        }

        public void AddFirst(T value)
        {
            Node<T> node = new Node<T>(value);
            if (numElems == 0)
            {
                head = node;
                tail = head;
            }
            else
            {
                node.next = head;
            }
            head = node;
            numElems++;

        }

        public bool RemoveFirst()
        {
            if (head == null)
            {
                return false;
            }
            if (head == tail)
            {
                head = tail = null;
            }
            else
            {
                head = head.next;
            }
            numElems--;
            return true;
        }
        public bool RemoveLast()
        {
            if (head == null)
            {
                return false;
            }
            if (head == tail)
            {
                head = tail = null;
            }
            else
            {
                Node<T>? prev = null;
                Node<T>? curr = head;
                while (curr.next != null)
                {
                    prev = curr;
                    curr = curr.next;
                }

                tail = prev;
                tail.next = null;
            }

            numElems--;
            return true;
        }
        public bool Contains(T value)
        {
            Node<T>? curr = head;
            while (curr != null)
            {
                if (curr.data.Equals(value))
                {
                    return true;
                }
                curr = curr.next;
            }
            return false;
        }
        public void Clear()
        {
            head = null;
            tail = null;
            numElems = 0;
        }
        public bool IsEmpty()
        {
            return numElems==0;
        }
        public T getHead()
        {
            return head.data;
        }
        public T getTail()
        {
            return tail.data;
        }
    }
    unsafe public class Node<T>
    {
        public Node<T> next { get; set; }
        public T data { get; set; }
        public Node(T data)
        {
            this.data = data;
        }
    }
}
