﻿using ProjectLinkor.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static System.Windows.Forms.LinkLabel;

namespace ProjectLinkor.CollectionGenericObjects;

public class DockService : AbstractCompany
{
    public DockService(int picWidth, int picHeight, ICollectionGenericObjects<DrawingShip> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new Pen(Color.Black, 4f);
        for (int i = 0; i < _pictureHeight / _placeSizeHeight / 2; i++)
        {
            g.DrawLine(pen, 0, _pictureHeight - i * _placeSizeHeight * 2, _placeSizeWidth * (_pictureWidth / _placeSizeWidth), _pictureHeight - i * _placeSizeHeight * 2);
            for (int j = 0; j < _pictureWidth / _placeSizeWidth + 1; j++)
            {
                g.DrawLine(pen, _placeSizeWidth * j, _pictureHeight - i * _placeSizeHeight * 2, _placeSizeWidth * j, _pictureHeight - i * _placeSizeHeight * 2 - _placeSizeHeight);
            }
        }

    }
    protected override void SetObjectsPosition()
    {
        int curPosX = 0;
        int curPosY = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            if (curPosX > _pictureWidth / _placeSizeWidth)
            {
                return;
            }
            if (_collection?.Get(i) != null)
            {
                _collection?.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);
                _collection?.Get(i)?.SetPosition(curPosX * _placeSizeWidth + 60, curPosY * _placeSizeHeight * -2 + _pictureHeight - 80);
            }

            if (curPosX < _pictureWidth / _placeSizeWidth - 1)
            {
                curPosX++;
            }
            else
            {
                curPosX = 0;
                curPosY++;
            }
        }
    }
}
